#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define DBG 0

int get_line(char *s, int max)
{
    int i;
    fgets(s,max,stdin);
    i = strlen(s) - 1;
    while (i >= 0 && s[i] == '\n')
        i--;
    i++;
    s[i] = 0;
    return i;
}

int sgetint(char **s, int *x)
{
    char *t = *s;
    
    while (isspace(*t)) t++;
    if (sscanf(t,"%d",x) != 1) return 0;
    while (*t && !isspace(*t)) t++;
    *s = t;
    return 1;
}
int dist(char * s, char * q)
{
	int di = 0;
	if (s == q)
		return 0;
	while (*s)
		di += *s++ != *q++;
	return di;
}
typedef struct {
	int start;
	int end;
	int we;
} thr;

char kody[2002][12];
thr hrany[2002*2002];
int hi;
int komparator(thr *a, thr *b)
{
	return (a->we<b->we) ? -1 : (a->we > b->we);
}
int getotec(int i) 
{
	while (i != les[i].otec)
		i = les[i].otec;
	return i;
}
typedef struct {
	int otec;
} tles;
tles les[10000];

int main(void)
{
	char line[50], *s = line;
	int N,i,j,total,run;
	int o1,o2;
	while (1) {
		scanf("%d\n",&N);
		if (!N)
			break;
		for (i = 0 ; i < N ; i++) {
			get_line(kody[i],9);
		}
		hi = 0;
		for (i = 0 ; i < N ; i++)
			for (j = 0 ; j < i ; j++ ) {
			    hrany[hi].start =i ;
				hrany[hi].end = j;
				hrany[hi].we = dist(kody[i],kody[j]);
				hi++;
			}

		qsort(hrany,hi,sizeof(hrany[0]),komparator);
		
		for (i = 0; i < N; i++) {
			les[i].otec = i;
		    les[i].hloubka = 0;
		}
		
		total = 0;
		for (i = 0; i < hi; i++) {
			o1 = getotec(hrany[i].start);
			o2 = getotec(hrany[i].end);
			if (o1 != o2) {
				total += hrany[i].we;
				les[o1].otec = o2;
			}				
		}
		/*
		min = 0x7fffffff;
		for (i = 0 ; i < N ; i++) {
			run = 0;
			for (j = 0 ; j < N ; j++ ) {
				run += graf[i][j];
			}
			if (min > run)
				min = run;
		}
		*/
		printf("The highest possible quality is 1/%d.\n",total);
	}
	return 0;
}
