#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

int get_line(char *s, int max)
{
    int i;
    fgets(s,max,stdin);
    i = strlen(s) - 1;
    while (i >= 0 && s[i] == '\n')
        i--;
    i++;
    s[i] = 0;
    return i;
}

int sgetint(char **s, int *x)
{
    char *t = *s;
    
    while (isspace(*t)) t++;
    if (sscanf(t,"%d",x) != 1) return 0;
    while (*t && !isspace(*t)) t++;
    *s = t;
    return 1;
}
typedef struct tnode {
	int vis;
	int id;
	struct tnode *prev, *next;
} tnode;

#define MAXBAYS 1000
#define MAXN    1000000
tnode node[MAXBAYS];
tnode *head, *tail;

int plus[MAXN];
int minus[MAXN];
int pc;

void add(int x)
{
	if (node[x].vis != 0) {
		if (head == tail) {
			/**/
		} else {
			if (node[x].prev != NULL) {
				node[x].prev->next = node[x].next;
			} else head = node[x].next;
			if (node[x].next != NULL) {
				node[x].next->prev = node[x].prev;
			} else tail = node[x].prev;
		}
	} else {
		node[x].vis = 1;
		if (head == NULL) {
			head = tail = &node[x];
			node[x].prev = node[x].next = NULL;
		} else {
			node[x].prev = NULL;
			node[x].next = head;
			head = &node[x];
		}
		cnt++;
		if (cnt > b) {
			minus[pc] = tail->id;
			tail->prev->next = NULL;
			tail = tail->prev;
		}
		pc++;
	}
}

int main(void)
{
	int cas, cases,b,g,n;
	scanf("%d",&cases);
	for (cas = 1; case <= cases;cas++) {
		scanf("%d %d %d",&b,&g,&n);
		printf("Case %d:\n",cas);
		for (i = 0; i < n; i++) {
			scanf("%d",&lst[i]);
		}
		for (i =0; i < b; i++) {
			node[i].vis = 0;
			node[i].id = i;
		}
		head = NULL;
		tail = NULL;
		cnt = 0;
		
		for (i = n - 1; i >= 0; i--)
			add(lst[i]);
	}
    return 0;
}
